; ##############################################################################
; ##############################################################################
; ##############################################################################
Watchdog_aktivieren:
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	cbi PORTB, LED_B_GRUEN	; an	
	cbi PORTB, LED_B_GELB	; an	
	cbi PORTB, LED_B_ROT	; an	
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM		
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER	
	ret
; SCHLEIFE, bis WDR zubeit		
PROGRAMM_CHECK_FEHLER:
	cbi PORTB, LED_B_ROT	; an	
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
BUS_BELEGT_CHECK:
	ldi temp1,255
	ldi temp2,255
	ldi temp3,255
BUS_BELEGT_CHECK_w:
	; PINS abfragen	
	in temp, PINC
	andi temp,0b00110000
	cpi  temp,0b00110000
	brne BUS_BELEGT_CHECK_ERROR
	ret

BUS_BELEGT_CHECK_ERROR:
    WDR					; WATCH-DOG		
	dec	temp1
	brne BUS_BELEGT_CHECK_w
	dec	temp2
	brne BUS_BELEGT_CHECK_w
	dec	temp3
	brne BUS_BELEGT_CHECK_w

; SCHLEIFE, bis WDR zubeit		
BUS_BELEGT_CHECK_ERROR_SCHLEIFE:
	rjmp BUS_BELEGT_CHECK_ERROR_SCHLEIFE

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
